#
# Conditional build:
%bcond_without	ssp	# stack-smashing protector
%bcond_with	dynamic	# dynamic lib support

%ifnarch %{ix86} %{x8664} %{arm}
%undefine	with_dynamic
%endif

Summary:	C library optimized for size
Summary(pl.UTF-8):	Biblioteka standardowa C zoptymalizowana na rozmiar
Summary(pt_BR.UTF-8):	libc pequena otimizada para tamanho
Name:		dietlibc
Version:	0.35
Release:	1
Epoch:		2
License:	GPL v2
Group:		Development/Libraries
Source0:	http://www.fefe.de/dietlibc/%{name}-%{version}.tar.xz
# Source0-md5:	100e0321b49fdfd2de8c63bc1e30aad8
Patch0:		%{name}-ppc.patch
Patch1:		%{name}-opt.patch
Patch2:		%{name}-platform.patch
Patch3:		%{name}-guard.patch
Patch4:		%{name}-arm.patch
Patch5:		%{name}-diet-m.patch
Patch6:		%{name}-syscalls.patch
Patch7:		%{name}-stackgap-instead-of-ssp.patch
Patch9:		%{name}-memalign.patch
Patch10:	%{name}-getsubopt.patch
Patch11:	%{name}-devmacros.patch
Patch12:	%{name}-notify.patch
Patch13:	x32-fixes.patch
Patch14:	%{name}-no-vsyscall.patch
Patch15:	absolute-cc-path.patch
URL:		http://www.fefe.de/dietlibc/
BuildRequires:	gcc >= 6:3.4
BuildRequires:	rpmbuild(macros) >= 2.005
BuildRequires:	sed >= 4.0
%ifarch sparc sparcv9
BuildRequires:	sparc32
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%undefine	_debugsource_packages

%define		dietprefix	%{_prefix}/lib/dietlibc
# for some reason known only to rpm there must be "\\|" not "\|" here
%define		libarch		%(echo %{_target_cpu} | sed -e 's/i.86\\|pentium.\\|athlon/i386/;s/amd64/x86_64/;s/armv.*/arm/;s/sparcv.*/sparc/')

%description
The diet libc is a libc that is optimized for small size. It can be
used to create small statically linked binaries for Linux on alpha,
arm, hppa, ia64, i386, mips, s390, sparc, sparc64, ppc and x86_64.

%description -l pl.UTF-8
diet libc to biblioteka libc zoptymalizowana pod kątem rozmiaru.
Może być używana do tworzenia małych, statycznie zlinkowanych
binariów dla Linuksa na architekturach alpha, arm, hppa, ia64, i386,
mips, s390, sparc, sparc64, ppc i x86_64.

%description -l pt_BR.UTF-8
A diet libc e' uma libc otimizada para criar pequenos binários
estaticamente linkados para Linux.

%package libs
Summary:	Shared dietlibc libraries
Summary(pl.UTF-8):	Biblioteki współdzielone dietlibc
Group:		Libraries

%description libs
This package contains the shared dietlibc libraries.

%description libs -l pl.UTF-8
Ten pakiet zawiera biblioteki współdzielone dietlibc.

%package devel
Summary:	Development files for dietlibc
Summary(pl.UTF-8):	Pliki dla programistów używających dietlibc
Summary(pt_BR.UTF-8):	libc pequena otimizada para tamanho
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
Small libc for building embedded applications - development files.

%description devel -l pl.UTF-8
Niewielka libc do budowania aplikacji wbudowanych - pliki dla
programistów.

%package static
Summary:	Static libraries for dietlibc
Summary(pl.UTF-8):	Biblioteki statyczne dla dietlibc
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Small libc for building embedded applications - static libraries.

%description static -l pl.UTF-8
Niewielka libc do budowania aplikacji wbudowanych - biblioteki
statyczne.

%prep
%setup -q
%undos arm/md5asm.S
%patch -P0 -p1
%patch -P1 -p1
%patch -P2 -p1
%patch -P3 -p1
%patch -P4 -p1
%patch -P5 -p1
%patch -P6 -p1
%{!?with_ssp:%patch -P7 -p1}
%patch -P9 -p1
%patch -P10 -p1
%patch -P11 -p1
%patch -P12 -p1
%patch -P13 -p1
%patch -P14 -p1
%patch -P15 -p1

%build
# needed for build, but can't be compiled before lib
%{__cc} %{rpmldflags} %{rpmcflags} %{rpmcppflags} -o json json.c

export OPTFLAGS="%{rpmcflags}%{?with_ssp: -fno-stack-protector} -fno-strict-aliasing -Wa,--noexecstack"
CC="%{__cc}"
%ifarch sparc sparcv9
sparc32 \
%endif
%{__make} -j1 all \
	MYARCH=%{libarch} \
	prefix=%{dietprefix} \
	CC="${CC#*ccache }" \
	STRIP=:

%if %{with dynamic}
# 'dyn' target is not SMP safe
%{__make} -j1 dyn \
	MYARCH=%{libarch} \
	prefix=%{dietprefix} \
	CC="${CC}" \
	STRIP=:
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_bindir},%{_mandir}/man1}

%ifarch sparc sparcv9
sparc32 \
%endif
%{__make} install \
	MYARCH=%{libarch} \
	DESTDIR=$RPM_BUILD_ROOT \
	prefix=%{dietprefix}

%{__mv} $RPM_BUILD_ROOT%{dietprefix}/bin/* $RPM_BUILD_ROOT%{_bindir}
%{__mv} $RPM_BUILD_ROOT%{dietprefix}/man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1
%{__rm} -r $RPM_BUILD_ROOT%{dietprefix}/{bin,man}
%{__rm} $RPM_BUILD_ROOT%{_bindir}/dnsd

cat > $RPM_BUILD_ROOT%{_bindir}/%{_target_cpu}-dietlibc-gcc <<'EOF'
#!/bin/sh
exec %{_bindir}/diet gcc "$@"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHOR BUGS CAVEAT CHANGES FAQ README THANKS TODO
%dir %{dietprefix}
%dir %{dietprefix}/lib-%{libarch}

%if %{with dynamic}
%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{dietprefix}/lib-%{libarch}/*.so
%{_sysconfdir}/diet.ld.conf
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*-dietlibc-gcc
%attr(755,root,root) %{_bindir}/diet
%attr(755,root,root) %{_bindir}/elftrunc
%{dietprefix}/lib-%{libarch}/*.o
%{dietprefix}/include
%{_mandir}/man1/diet.1*

%files static
%defattr(644,root,root,755)
%{dietprefix}/lib-%{libarch}/*.a
%changelog
* Fri Apr 11 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dietlibc.git;a=log;h=master

* Fri Apr 11 2025 Jakub Bogusz <qboosh@pld-linux.org> 1d7c5a0
- add missing __NR_close_range also on x32

* Thu Apr 10 2025 Jakub Bogusz <qboosh@pld-linux.org> 0f96c2b
- updated to 0.35

* Thu Feb 13 2025 Jan Palus <atler@pld-linux.org> 2cfd24e
- semantics of _debugsource_packages changed now...; rel 3

* Thu Feb 13 2025 Jan Palus <atler@pld-linux.org> 47030aa
- handle absolute cc path during platform determination; rel 2

* Wed Feb 12 2025 Jan Palus <atler@pld-linux.org> d5d6fc0
- macros for %_debugsource_packages

* Wed Feb 12 2025 Jan Palus <atler@pld-linux.org> 956bbbf
- use %patch -P

* Wed Dec 04 2024 Marcin Krol <hawk@tld-linux.org> 9e520ea
- disable debug packages (error: Empty %files file /tmp/B.xvqe5yad/BUILD/dietlibc-0.34/debugsourcefiles.list)

* Tue Dec 03 2024 Marcin Krol <hawk@tld-linux.org> 2da47d9
- rediffed

* Sat Nov 14 2020 Jan Palus <atler@pld-linux.org> 514b1e9
- always pass MYARCH explicitly

* Sat May 02 2020 Jan Palus <atler@pld-linux.org> d18630a
- updated memalign patch; rel 1

* Wed Apr 22 2020 Jan Palus <atler@pld-linux.org> 8f178a7
- up to 0.34 (rel 0.1 memalign patch needs update)

* Thu Feb 08 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 015bcd3
- rel 5; seems that disabling vsyscall is possible, so try it after all

* Wed Jan 10 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> b426b10
- vsyscall note

* Thu Feb 26 2015 Jan Rękorajski <baggins@pld-linux.org> bb51f87
- disable dyn lib support, it's currently btoken on all archs
- rel 4

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 90c145f
- x32 rebuild
- release 3 (by relup.sh)

* Sat Jan 03 2015 Jan Rękorajski <baggins@pld-linux.org> b259987
- more patches updated

* Sat Jan 03 2015 Jan Rękorajski <baggins@pld-linux.org> 7f75a36
- updated patches for git updates

* Thu Jan 01 2015 Jan Rękorajski <baggins@pld-linux.org> 47ba338
- renumbered patches

* Thu Jan 01 2015 Jan Rękorajski <baggins@pld-linux.org> f5ffcb6
- added git patch updating to current devel state
- removed patches obsoleted by git update
- added x32 fixes

* Tue Jan 28 2014 Jan Rękorajski <baggins@pld-linux.org> 59e1441
- release 2 (by relup.sh)

